/****************************************************************************
** $Id: layout.cpp,v 1.3 1999/06/08 11:19:14 paul Exp $
**
** Copyright (C) 1992-1999 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#include <qapplication.h>
#include <qlabel.h>
#include <qcolor.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qmenubar.h>
#include <qpopupmenu.h>

#include "shmemblock.h"


class BVWidget : public QWidget
{
  Q_OBJECT
public:
  BVWidget(SharedVariables *shm, QWidget *parent = 0, const char *name = 0);
  ~BVWidget();
  
public slots:
  void BVvdo ();
  void BVodoTx ();
  void BVodoRx ();

protected:

private:
  QPushButton *vdobut;
  QPushButton *odobut;
  
  int *flag;
  sem_t *AS, *AR;
};


BVWidget::BVWidget(SharedVariables *shm, QWidget *parent, const char *name) 
  : QWidget(parent, name)
{
  // Make the top-level layout; a vertical box to contain all widgets
  // and sub-layouts.
  QBoxLayout *topLayout = new QVBoxLayout( this, 3);

  *flag = shm->lvdo_flag;
  *AS = shm->AS;
  *AR = shm->AR;

  // Create a menubar...
  QMenuBar *menubar = new QMenuBar( this );
  menubar->setSeparator( QMenuBar::InWindowsStyle );
  QPopupMenu* popup;
  popup = new QPopupMenu;
  popup->insertItem( "&Quit", qApp, SLOT(quit()) );
  menubar->insertItem( "&File", popup );

  // ...and tell the layout about it.
  topLayout->setMenuBar( menubar );

  // VIDEO : Make an hbox that will hold a row of buttons.
  QBoxLayout *vdobox = new QHBoxLayout( topLayout);
  vdobut = new QPushButton( this );
  QString s;
  s.sprintf( "Video : Local View");
  vdobut->setText( s );
  vdobox->addWidget(vdobut);
  // ... and make the second one a toggle button 
  vdobut->setToggleButton( TRUE );
  vdobut->setOn(FALSE);
  connect(vdobut, SIGNAL(clicked()), this, SLOT(BVvdo ()));  

  // AUDIO : Make an audio hbox that will hold a row of buttons.
  QBoxLayout *odobox = new QHBoxLayout( topLayout );
  odobut = new QPushButton( this );
  QString odoS;
  odoS.sprintf ( "Audio : Push to Talk!");
  odobut->setText( odoS );
  odobox->addWidget(odobut );
  connect(odobut, SIGNAL(pressed()), this, SLOT(BVodoTx()) );  

  topLayout->activate();
}

BVWidget::~BVWidget()
{
}


void BVWidget::BVvdo ()
{
  *flag = 1;
}


void BVWidget::BVodoTx ()
{
  connect(odobut, SIGNAL(released()), this, SLOT(BVodoRx ()) );  
  QString odoS;
  odoS.sprintf ( "Audio : Pull to Listen!");
  odobut->setText( odoS );

//    sem_wait (AR);
//    sem_post (AS);

}


void BVWidget::BVodoRx ()
{

  QString odoS;
  odoS.sprintf ( "Audio : Push to Talk!");
  odobut->setText( odoS );

//    sem_wait (AS);
//    sem_post (AR);

}

/* under this, it is main.cpp */
//  #include "layout.moc"

//    int main ( int argc, char **argv )
//   {
//      QApplication a ( argc, argv );

//      BVWidget *f = new BVWidget;
//      f->setCaption ("BuenaVista");
//      a.setMainWidget (f);
//      f->show ();

//      a.connect ( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );

//      return a.exec();
//    }

